Index: gcc/testsuite/gcc.target/i386/avx2-vbroadcastsi128-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx2-vbroadcastsi128-1.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.target/i386/avx2-vbroadcastsi128-1.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -10,5 +10,5 @@
 void extern
 avx2_test (void)
 {
-  x = _mm_broadcastsi128_si256 (y);
+  x = _mm256_broadcastsi128_si256 (y);
 }
Index: gcc/testsuite/gcc.target/i386/pr56866.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr56866.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.target/i386/pr56866.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,16 @@
+/* PR target/56866 */
+/* { dg-do run } */
+/* { dg-require-effective-target xop } */
+/* { dg-options "-O3 -mxop" } */
+
+#define main xop_test_main
+#include "../../gcc.c-torture/execute/pr56866.c"
+#undef main
+
+#include "xop-check.h"
+
+static void
+xop_test (void)
+{
+  xop_test_main ();
+}
Index: gcc/testsuite/gcc.target/i386/pr56903.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr56903.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.target/i386/pr56903.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,18 @@
+/* PR rtl-optimization/56903 */
+/* { dg-do compile } */
+/* { dg-options "-Os" } */
+/* { dg-additional-options "-march=pentium3" { target ia32 } } */
+
+int a, *b, c;
+struct S { int s : 1; } *fn1 (void);
+extern int fn3 (void), fn4 (int *);
+
+void
+fn2 (void)
+{
+  int e = fn3 ();
+  char f = c + fn1 ()->s * 4;
+  if (*b && f == e)
+    a = *b;
+  fn4 (b);
+}
Index: gcc/testsuite/gcc.target/i386/pr57098.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr57098.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.target/i386/pr57098.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target lp64 } */
+/* { dg-options "-msse4 -mcmodel=large" } */
+
+typedef int V __attribute__((vector_size(16)));
+
+void foo (V *p, V *mask)
+{
+  *p = __builtin_shuffle (*p, *mask);
+}
Index: gcc/testsuite/gcc.target/i386/pr57106.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr57106.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.target/i386/pr57106.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fschedule-insns -funroll-all-loops -fcompare-debug" } */
+
+typedef void block128_f (int *, int);
+
+void
+foo (int *out, int *iv, block128_f block)
+{
+  while (1)
+    {
+      *out = *out ^ *iv;
+      block (out, *out);
+      iv = out;
+    }
+}
Index: gcc/testsuite/gcc.target/i386/avx2-vbroadcastsi128-2.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx2-vbroadcastsi128-2.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.target/i386/avx2-vbroadcastsi128-2.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -19,7 +19,7 @@
       for (j = 0; j < 2; j++)
 	s1.a[j] = j * i;
 
-      res.x = _mm_broadcastsi128_si256 (s1.x);
+      res.x = _mm256_broadcastsi128_si256 (s1.x);
 
       memcpy (res_ref, s1.a, 16);
       memcpy (res_ref + 2, s1.a, 16);
Index: gcc/testsuite/gcc.target/i386/mmx-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mmx-1.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.target/i386/mmx-1.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,5 @@
 /* { dg-do compile } */
+/* { dg-do compile { target { nonpic } } } */
 /* { dg-options "-O2 -Werror-implicit-function-declaration -mmmx" } */
 
 /* Test that the intrinsics compile with optimization.  All of them are
Index: gcc/testsuite/gcc.target/i386/pr57091.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr57091.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.target/i386/pr57091.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,8 @@
+/* { dg-do compile } */
+/* { dg-options "-O -mcmodel=large"  { target lp64 } } */
+void (*bar)();
+
+void foo (void)
+{
+  bar ();
+}
Index: gcc/testsuite/gcc.target/sh/pr57108.c
===================================================================
--- gcc/testsuite/gcc.target/sh/pr57108.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.target/sh/pr57108.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,19 @@
+/* { dg-do compile { target "sh*-*-*" } } */
+/* { dg-options "-O1" } */
+
+void __assert_func (void) __attribute__ ((__noreturn__)) ;
+
+void ATATransfer (int num, int buffer)
+{
+ int wordCount;
+
+ while (num > 0)
+  {
+    wordCount = num * 512 / sizeof (int);
+
+    ((0 == (buffer & 63)) ? (void)0 : __assert_func () );
+    ((0 == (wordCount & 31)) ? (void)0 : __assert_func ());
+  }
+
+
+ }
Index: gcc/testsuite/gfortran.dg/eof_5.f90
===================================================================
--- gcc/testsuite/gfortran.dg/eof_5.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/eof_5.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,21 @@
+! { dg-do run }
+!
+! PR fortran/56696
+!
+! Contributed by Keith Refson
+!
+
+program iotest
+   character(len=258) :: inp = ' 1.0 1.0 1.0'
+   character(len=7) :: inp2 = '1 2 3 4'
+   integer :: ios
+   real :: a1, a2, a3, a4
+
+   read(inp2,*,iostat=ios) a1, a2, a3, a4
+   if (ios /= 0) call abort ()
+
+   read(inp,*,iostat=ios) a1, a2, a3, a4
+   if (ios == 0) call abort ()
+!   write(*,*) 'IOSTAT=',ios
+end program iotest
+
Index: gcc/testsuite/gfortran.dg/size_kind_3.f90
===================================================================
--- gcc/testsuite/gfortran.dg/size_kind_3.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/size_kind_3.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,11 @@
+! { dg-do compile }
+!
+! PR fortran/57142
+!
+integer :: B(huge(1)+3_8,2_8)
+integer(8) :: var1(2), var2, var3
+
+var1 = shape(B) ! { dg-error "SHAPE overflows its kind" }
+var2 = size(B) ! { dg-error "SIZE overflows its kind" }
+var3 = size(B,dim=1) ! { dg-error "SIZE overflows its kind" }
+end
Index: gcc/testsuite/gfortran.dg/transfer_check_4.f90
===================================================================
--- gcc/testsuite/gfortran.dg/transfer_check_4.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/transfer_check_4.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,44 @@
+! { dg-do compile }
+! { dg-options "-Wall" }
+
+! PR 57022: [4.7/4.8/4.9 Regression] Inappropriate warning for use of TRANSFER with arrays
+! Contributed by William Clodius <wclodius@los-alamos.net>
+
+subroutine transfers (test)
+
+  use, intrinsic :: iso_fortran_env
+  
+  integer, intent(in) :: test
+
+  integer(int8)  :: test8(8)  = 0
+  integer(int16) :: test16(4) = 0
+  integer(int32) :: test32(2) = 0
+  integer(int64) :: test64    = 0
+
+  select case(test)
+  case(0)
+    test64 = transfer(test8, test64)
+  case(1)
+    test64 = transfer(test16, test64)
+  case(2)
+    test64 = transfer(test32, test64)
+  case(3)
+    test8  = transfer(test64, test8, 8)
+  case(4)
+    test16 = transfer(test64, test16, 4)
+  case(5)
+    test32 = transfer(test64, test32, 2)
+  end select
+
+end subroutine
+
+
+! PR 53685: surprising warns about transfer with explicit character range
+! Contributed by Jos de Kloe <kloedej@knmi.nl>
+
+subroutine mytest(byte_array,val)
+  integer, parameter :: r8_ = Selected_Real_Kind(15,307)  ! = real*8
+  character(len=1), dimension(16), intent(in) :: byte_array
+  real(r8_),intent(out) :: val
+  val = transfer(byte_array(1:8),val)    
+end subroutine
Index: gcc/testsuite/gfortran.dg/namelist_80.f90
===================================================================
--- gcc/testsuite/gfortran.dg/namelist_80.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/namelist_80.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,27 @@
+! { dg-do run }
+!
+! PR fortran/56735
+!
+! Contributed by Adam Williams
+!
+        PROGRAM TEST
+        INTEGER int1,int2,int3
+        NAMELIST /temp/ int1,int2,int3
+
+        int1 = -1; int2 = -2; int3 = -3
+
+        OPEN (53, STATUS='scratch')
+        WRITE (53, '(a)') ' ?'
+        WRITE (53, '(a)')
+        WRITE (53, '(a)') '$temp'
+        WRITE (53, '(a)') ' int1=1'
+        WRITE (53, '(a)') ' int2=2'
+        WRITE (53, '(a)') ' int3=3'
+        WRITE (53, '(a)') '$END'
+        REWIND(53)
+
+        READ (53, temp)
+        CLOSE (53)
+
+        if (int1 /= 1 .or. int2 /= 2 .or. int3 /= 3) call abort()
+        END PROGRAM
Index: gcc/testsuite/gfortran.dg/proc_ptr_42.f90
===================================================================
--- gcc/testsuite/gfortran.dg/proc_ptr_42.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/proc_ptr_42.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,36 @@
+! { dg-do compile }
+!
+! PR 56814: [4.8/4.9 Regression] Bogus Interface mismatch in dummy procedure
+!
+! Contributed by Marco Restelli <mrestelli@gmail.com>
+
+module m1
+  abstract interface
+    pure function i_f(x) result(d)
+    real, intent(in) :: x(:,:)
+    real :: d(size(x,1),size(x,2))
+    end function
+  end interface
+
+  procedure(i_f), pointer :: f => null()
+end module
+
+module m2
+contains
+  pure subroutine ns_dirdata(fun)
+    interface
+    pure function fun(x) result(d)
+      real, intent(in) :: x(:,:)
+      real :: d(size(x,1),size(x,2))
+    end function
+    end interface
+  end subroutine
+end module
+
+program p
+ use m1
+ use m2
+  call ns_dirdata(f)
+end
+
+! { dg-final { cleanup-modules "m1 m2" } }
Index: gcc/testsuite/gfortran.dg/select_type_33.f03
===================================================================
--- gcc/testsuite/gfortran.dg/select_type_33.f03	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/select_type_33.f03	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,43 @@
+! { dg-do compile }
+!
+! PR fortran/56816
+! The unfinished SELECT TYPE statement below was leading to an ICE because
+! at the time the statement was rejected, the compiler tried to free
+! some symbols that had already been freed with the SELECT TYPE
+! namespace.
+!
+! Original testcase from Dominique Pelletier <dominique.pelletier@polymtl.ca>
+!
+module any_list_module
+    implicit none
+
+    private
+    public :: anylist, anyitem
+
+    type anylist
+    end type
+
+    type anyitem
+        class(*), allocatable :: value
+    end type
+end module any_list_module
+
+
+module my_item_list_module
+
+    use any_list_module
+    implicit none
+
+    type, extends (anyitem) :: myitem
+    end type myitem
+
+contains
+
+    subroutine myprint (this)
+        class (myitem) ::   this
+
+        select type ( v => this % value ! { dg-error "parse error in SELECT TYPE" }
+        end select                      ! { dg-error "Expecting END SUBROUTINE" }
+    end subroutine myprint
+
+end module my_item_list_module
Index: gcc/testsuite/gfortran.dg/array_constructor_45.f90
===================================================================
--- gcc/testsuite/gfortran.dg/array_constructor_45.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/array_constructor_45.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+! { dg-do run }
+! PR PR 56872 - wrong front-end optimization with a
+! single array constructor and another value.
+program main
+  real    :: s
+  integer :: m
+  integer :: k
+  real :: res
+
+  m = 2
+  s = 1000.
+
+  res = SUM([3.0,(s**(REAL(k-1)/REAL(m-1)),k=1,m),17.])
+  if (abs(res - 1021.)>1e-4) call abort
+end
Index: gcc/testsuite/gfortran.dg/namelist_77.f90
===================================================================
--- gcc/testsuite/gfortran.dg/namelist_77.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/namelist_77.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,49 @@
+! { dg-do run }
+!
+! PR libfortran/51825 - Fortran runtime error: Cannot match namelist object name
+! Test case derived from PR.
+
+module local_mod
+
+    type mytype1
+        integer :: int1
+    end type
+
+    type mytype2
+        integer :: n_x       
+        integer :: n_px        
+    end type
+
+    type beam_init_struct
+        character(16) :: chars(1) = ''                                  
+        type (mytype1) dummy
+        type (mytype2) grid(1)      
+    end type
+
+end module
+
+program error_namelist
+
+    use local_mod
+
+    implicit none
+
+    type (beam_init_struct) beam_init
+
+    namelist / error_params / beam_init
+
+    open (10, status='scratch')
+    write (10, '(a)') "&error_params"
+    write (10, '(a)') "  beam_init%chars(1)='JUNK'"
+    write (10, '(a)') "  beam_init%grid(1)%n_x=3"
+    write (10, '(a)') "  beam_init%grid(1)%n_px=2"
+    write (10, '(a)') "/"
+    rewind(10)
+    read(10, nml=error_params)
+    close (10)
+
+    if (beam_init%chars(1) /= 'JUNK') call abort
+    if (beam_init%grid(1)%n_x /= 3) call abort
+    if (beam_init%grid(1)%n_px /= 2) call abort
+
+end program
Index: gcc/testsuite/gfortran.dg/array_constructor_47.f90
===================================================================
--- gcc/testsuite/gfortran.dg/array_constructor_47.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/array_constructor_47.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,24 @@
+! { dg-do run }
+! { dg-options "-ffrontend-optimize -fdump-tree-original" }
+! Test that reduction optimization doesn't break with a function expression
+! in an array constructor. 
+program main
+  implicit none
+  integer, parameter :: dp=selected_real_kind(15)
+  real(kind=dp), dimension(2,2) :: a
+  real(kind=dp) thirteen
+
+  data a /2._dp,3._dp,5._dp,7._dp/
+  thirteen = 13._dp
+  if (abs (product([[sum([eleven_ones()]), thirteen], a]) - 30030._dp) > 1e-8) call abort
+ contains
+  function eleven_ones()
+    real(kind=dp) :: eleven_ones(11)
+    integer       :: i
+
+    eleven_ones = [ (1._dp, i=1,11) ]
+  end function eleven_ones
+end program main
+! { dg-final { scan-tree-dump-times "while" 4 "original" } }
+! { dg-final { cleanup-tree-dump "original" } }
+
Index: gcc/testsuite/gfortran.dg/do_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/do_1.f90	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gfortran.dg/do_1.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,5 +1,4 @@
-! { dg-do run { xfail *-*-* } }
-! XFAIL is tracked in PR 54932
+! { dg-do run }
 ! Program to check corner cases for DO statements.
 program do_1
   implicit none
Index: gcc/testsuite/gfortran.dg/namelist_79.f90
===================================================================
--- gcc/testsuite/gfortran.dg/namelist_79.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/namelist_79.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,43 @@
+! { dg-do run }
+! PR libfortran/52512 - Cannot match namelist object name
+! Test case derived from PR.
+
+program testje
+
+    implicit none
+
+    integer :: getal, jn
+    type ptracer
+        character(len = 8)  :: sname  !: short name
+        logical             :: lini   !: read in a file or not
+    end type ptracer
+    type(ptracer) , dimension(3) :: tracer
+    namelist/namtoptrc/  getal,tracer
+
+    ! standard values
+    getal = 9999
+    do jn = 1, 3
+        tracer(jn)%sname = 'default_name'
+        tracer(jn)%lini = .false.
+    end do
+
+    open (10, status='scratch')
+    write (10, '(a)') "&namtoptrc"
+    write (10, '(a)') "   getal = 7"
+    write (10, '(a)') "   tracer(1) = 'DIC     ', .true."
+    write (10, '(a)') "   tracer(2) = 'Alkalini', .true."
+    write (10, '(a)') "   tracer(3) = 'O2      ', .true."
+    write (10, '(a)') "/"
+    rewind(10)
+    read(10, nml=namtoptrc)
+    close (10)
+
+    if (getal /= 7) call abort
+    if (tracer(1)%sname /= 'DIC     ') call abort
+    if (tracer(2)%sname /= 'Alkalini') call abort
+    if (tracer(3)%sname /= 'O2      ') call abort
+    if (.not. tracer(1)%lini) call abort
+    if (.not. tracer(2)%lini) call abort
+    if (.not. tracer(3)%lini) call abort
+
+end program testje
Index: gcc/testsuite/gfortran.dg/size_kind_2.f90
===================================================================
--- gcc/testsuite/gfortran.dg/size_kind_2.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/size_kind_2.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,17 @@
+! { dg-do compile }
+! { dg-options "-fdump-tree-original" }
+!
+! PR fortran/57142
+!
+integer :: B(huge(1)+3_8,2_8)
+integer(8) :: var1(2), var2, var3
+
+var1 = shape(B,kind=8)
+var2 = size(B,kind=8)
+var3 = size(B,dim=1,kind=8)
+end
+
+! { dg-final { scan-tree-dump "static integer.kind=8. A..\\\[2\\\] = \\\{2147483650, 2\\\};" "original" } }
+! { dg-final { scan-tree-dump "var2 = 4294967300;" "original" } }
+! { dg-final { scan-tree-dump "var3 = 2147483650;" "original" } }
+! { dg-final { cleanup-tree-dump "original" } }
Index: gcc/testsuite/gfortran.dg/array_constructor_40.f90
===================================================================
--- gcc/testsuite/gfortran.dg/array_constructor_40.f90	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gfortran.dg/array_constructor_40.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -48,5 +48,5 @@
   call baz(a,b,res);
   if (abs(res - 8.1) > 1e-5) call abort
 end program main
-! { dg-final { scan-tree-dump-times "while" 3 "original" } }
+! { dg-final { scan-tree-dump-times "while" 5 "original" } }
 ! { dg-final { cleanup-tree-dump "original" } }
Index: gcc/testsuite/gfortran.dg/proc_ptr_41.f90
===================================================================
--- gcc/testsuite/gfortran.dg/proc_ptr_41.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/proc_ptr_41.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,37 @@
+! { dg-do compile }
+!
+! PR 56968: [4.7/4.8/4.9 Regression] [F03] Issue with a procedure defined with a generic name returning procedure pointer
+!
+! Contributed by Samuel Debionne <samuel.debionne@ujf-grenoble.fr>
+
+module test
+
+  interface generic_name_get_proc_ptr
+    module procedure specific_name_get_proc_ptr
+  end interface
+
+  abstract interface
+    double precision function foo(arg1)
+      real, intent(in) :: arg1
+    end function
+  end interface
+
+contains
+
+  function specific_name_get_proc_ptr() result(res)
+    procedure(foo), pointer :: res
+  end function
+
+end module test
+
+program crash_test
+    use :: test
+
+    procedure(foo), pointer :: ptr
+
+    ptr => specific_name_get_proc_ptr()
+    ptr => generic_name_get_proc_ptr()
+
+end program
+
+! { dg-final { cleanup-modules "test" } }
Index: gcc/testsuite/gfortran.dg/namelist_81.f90
===================================================================
--- gcc/testsuite/gfortran.dg/namelist_81.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/namelist_81.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,43 @@
+! { dg-do run }
+! PR56786 Error on embedded spaces
+integer :: i(3)
+namelist /nml/ i
+
+i = -42
+open(99,status='scratch')
+write(99,'(a)') '&nml i(3 ) = 5 /'
+rewind(99)
+read(99,nml=nml)
+close(99)
+if (i(1)/=-42 .or. i(2)/=-42 .or. i(3)/=5) call abort()
+
+! Shorten the file so the read hits EOF
+
+open(99,status='scratch')
+write(99,'(a)') '&nml i(3 ) = 5 '
+rewind(99)
+read(99,nml=nml, end=30)
+call abort()
+! Shorten some more
+ 30 close(99)
+open(99,status='scratch')
+write(99,'(a)') '&nml i(3 ) ='
+rewind(99)
+read(99,nml=nml, end=40)
+call abort()
+! Shorten some more
+ 40 close(99)
+open(99,status='scratch')
+write(99,'(a)') '&nml i(3 )'
+rewind(99)
+read(99,nml=nml, end=50)
+call abort()
+! Shorten some more
+ 50 close(99)
+open(99,status='scratch')
+write(99,'(a)') '&nml i(3 '
+rewind(99)
+read(99,nml=nml, end=60)
+call abort()
+ 60 close(99)
+end
Index: gcc/testsuite/gfortran.dg/array_constructor_44.f90
===================================================================
--- gcc/testsuite/gfortran.dg/array_constructor_44.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/array_constructor_44.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,12 @@
+! { dg-do run }
+! { dg-options "-ffrontend-optimize" }
+! PR 56872 - wrong front-end optimization with a single constructor.
+! Original bug report by Rich Townsend.
+  integer :: k
+  real :: s
+  integer :: m
+  s = 2.0
+  m = 4
+  res = SUM([(s**(REAL(k-1)/REAL(m-1)),k=1,m)])
+  if (abs(res - 5.84732246) > 1e-6) call abort
+  end
Index: gcc/testsuite/gfortran.dg/array_constructor_46.f90
===================================================================
--- gcc/testsuite/gfortran.dg/array_constructor_46.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/array_constructor_46.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+! { dg-do run }
+! { dg-options "-ffrontend-optimize -fdump-tree-original" }
+! Test that nested array constructors are optimized.
+program main
+  implicit none
+  integer, parameter :: dp=selected_real_kind(15)
+  real(kind=dp), dimension(2,2) :: a
+  real(kind=dp) thirteen
+
+  data a /2._dp,3._dp,5._dp,7._dp/
+  thirteen = 13._dp
+  if (abs (product([[11._dp, thirteen], a]) - 30030._dp) > 1e-8) call abort
+end program main
+! { dg-final { scan-tree-dump-times "while" 2 "original" } }
+! { dg-final { cleanup-tree-dump "original" } }
Index: gcc/testsuite/gfortran.dg/namelist_78.f90
===================================================================
--- gcc/testsuite/gfortran.dg/namelist_78.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/namelist_78.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,34 @@
+! { dg-do run }
+!
+! PR libfortran/51825
+! Test case regarding namelist problems with derived types
+
+program namelist
+
+    type d1
+        integer :: j = 0
+    end type d1
+
+    type d2
+        type(d1) k
+    end type d2
+
+    type d3
+        type(d2) d(2)
+    end type d3
+
+    type(d3) der
+    namelist /nmlst/ der
+
+    open (10, status='scratch')
+    write (10, '(a)') "&NMLST"
+    write (10, '(a)') " DER%D(1)%K%J = 1,"
+    write (10, '(a)') " DER%D(2)%K%J = 2,"
+    write (10, '(a)') "/"
+    rewind(10)
+    read(10, nml=nmlst)
+    close (10)
+
+    if (der%d(1)%k%j /= 1) call abort
+    if (der%d(2)%k%j /= 2) call abort
+end program namelist
Index: gcc/testsuite/gfortran.dg/fmt_cache_3.f90
===================================================================
--- gcc/testsuite/gfortran.dg/fmt_cache_3.f90	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gfortran.dg/fmt_cache_3.f90	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,80 @@
+! { dg-do run }
+!
+! PR fortran/56737
+!
+! Contributed by Jonathan Hogg
+!
+module hsl_mc73_single
+   implicit none
+   integer, parameter, private :: wp = kind(0.0)
+contains
+   subroutine mc73_fiedler(n,lirn,irn,ip,list)
+      integer,  intent (in) :: n
+      integer,  intent (in) :: lirn
+      integer,  intent (in) :: irn(*)
+      integer,  intent (in) :: ip(*)
+      integer, intent (out) :: list(*)
+
+      integer :: icntl(10)
+
+      call fiedler_graph(icntl)
+   end subroutine mc73_fiedler
+
+   subroutine mc73_order
+      integer :: icntl(10)
+
+      call fiedler_graph(icntl)
+   end subroutine mc73_order
+
+   subroutine fiedler_graph(icntl)
+      integer,  intent (in) :: icntl(10)
+
+      real (kind = wp)  :: tol
+      real (kind = wp)  :: tol1
+      real (kind = wp)  :: rtol
+
+      call multilevel_eig(tol,tol1,rtol,icntl)
+   end subroutine fiedler_graph
+
+   subroutine multilevel_eig(tol,tol1,rtol,icntl)
+      real (kind = wp), intent (in) :: tol,tol1,rtol
+      integer,  intent(in) :: icntl(10)
+
+      call level_print(6,'end of level ',1)
+   end subroutine multilevel_eig
+
+   subroutine level_print(mp,title1,level)
+      character (len = *), intent(in) :: title1
+      integer,  intent(in) :: mp,level
+      character(len=80) fmt
+      integer :: char_len1,char_len2
+
+      char_len1=len_trim(title1)
+
+      write (fmt,"('(',i4,'(1H ),6h===== ,a',i4,',i4,6h =====)')") &
+           level*3, char_len1
+!      print *, "fmt = ", fmt
+!      print *, "title1= ", title1
+!      print *, "level = ", level
+      write (66,fmt) title1,level
+   end subroutine level_print
+end module hsl_mc73_single
+
+program test
+   use hsl_mc73_single
+   implicit none
+   character(len=200) :: str(2)
+   integer, parameter :: wp = kind(0.0)
+
+   integer :: n, lirn
+   integer :: irn(1), ip(1), list(1)
+
+   str = ""
+   open (66, status='scratch')
+   call mc73_order
+   call mc73_fiedler(n,lirn,irn,ip,list)
+   rewind (66)
+   read (66, '(a)') str
+   close (66)
+   if (any (str /= "   ===== end of level   1 =====")) call abort()
+end program test
Index: gcc/testsuite/gcc.c-torture/execute/pr57281.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr57281.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr57281.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,25 @@
+/* PR rtl-optimization/57281 */
+
+int a = 1, b, d, *e = &d;
+long long c, *g = &c;
+volatile long long f;
+
+int
+foo (int h)
+{
+  int j = *g = b;
+  return h == 0 ? j : 0;
+}
+
+int
+main ()
+{
+  int h = a;
+  for (; b != -20; b--)
+    {
+      (int) f;
+      *e = 0;
+      *e = foo (h);
+    }
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr33992.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr33992.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.c-torture/execute/pr33992.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -7,7 +7,7 @@
     abort ();
 }
 
-void __attribute__((always_inline))
+static void __attribute__((always_inline))
 foo (unsigned long long *r)
 {
   int i;
Index: gcc/testsuite/gcc.c-torture/execute/pr56899.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr56899.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr56899.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,47 @@
+/* PR tree-optimization/56899 */
+
+#if __SIZEOF_INT__ == 4 && __CHAR_BIT__ == 8
+__attribute__((noinline, noclone)) void
+f1 (int v)
+{
+  int x = -214748365 * (v - 1);
+  if (x != -1932735285)
+    __builtin_abort ();
+}
+
+__attribute__((noinline, noclone)) void
+f2 (int v)
+{
+  int x = 214748365 * (v + 1);
+  if (x != -1932735285)
+    __builtin_abort ();
+}
+
+__attribute__((noinline, noclone)) void
+f3 (unsigned int v)
+{
+  unsigned int x = -214748365U * (v - 1);
+  if (x != -1932735285U)
+    __builtin_abort ();
+}
+
+__attribute__((noinline, noclone)) void
+f4 (unsigned int v)
+{
+  unsigned int x = 214748365U * (v + 1);
+  if (x != -1932735285U)
+    __builtin_abort ();
+}
+#endif
+
+int
+main ()
+{
+#if __SIZEOF_INT__ == 4 && __CHAR_BIT__ == 8
+  f1 (10);
+  f2 (-10);
+  f3 (10);
+  f4 (-10U);
+#endif
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr57131.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr57131.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr57131.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,19 @@
+/* PR rtl-optimization/57131 */
+
+extern void abort (void);
+
+int
+main ()
+{
+  volatile int x1 = 0;
+  volatile long long x2 = 0;
+  volatile int x3 = 0;
+  volatile int x4 = 1;
+  volatile int x5 = 1;
+  volatile long long x6 = 1;
+  long long t = ((x1 * (x2 << x3)) / (x4 * x5)) + x6;
+
+  if (t != 1)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/builtins/builtins.exp
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/builtins/builtins.exp	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.c-torture/execute/builtins/builtins.exp	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -43,7 +43,8 @@
 }
 if { [istarget *-*-eabi*]
      || [istarget *-*-elf]
-     || [istarget *-*-mingw*] } {
+     || [istarget *-*-mingw*]
+     || [istarget *-*-rtems*] } {
    lappend additional_flags "-Wl,--allow-multiple-definition"
 }
 
Index: gcc/testsuite/gcc.c-torture/execute/pr57130.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr57130.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr57130.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,21 @@
+/* PR rtl-optimization/57130 */
+
+struct S { int a, b, c, d; } s[2] = { { 6, 8, -8, -5 }, { 0, 2, -1, 2 } };
+
+__attribute__((noinline, noclone)) void
+foo (struct S r)
+{
+  static int cnt;
+  if (__builtin_memcmp (&r, &s[cnt++], sizeof r) != 0)
+    __builtin_abort ();
+}
+
+int
+main ()
+{
+  struct S r = { 6, 8, -8, -5 };
+  foo (r);
+  r = (struct S) { 0, 2, -1, 2 };
+  foo (r);
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr56837.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr56837.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr56837.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,21 @@
+extern void abort (void);
+_Complex int a[1024];
+
+__attribute__((noinline, noclone)) void
+foo (void)
+{
+  int i;
+  for (i = 0; i < 1024; i++)
+    a[i] = -1;
+}
+
+int
+main ()
+{
+  int i;
+  foo ();
+  for (i = 0; i < 1024; i++)
+    if (a[i] != -1)
+      abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr57321.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr57321.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr57321.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,24 @@
+/* PR tree-optimization/57321 */
+
+int a = 1, *b, **c;
+
+static int
+foo (int *p)
+{
+  if (*p == a)
+    {
+      int *i[7][5] = { { 0 } };
+      int **j[1][1];
+      j[0][0] = &i[0][0];
+      *b = &p != c;
+    }
+  return 0;
+}
+
+int
+main ()
+{
+  int i = 0;
+  foo (&i);
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr56962.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr56962.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr56962.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,30 @@
+/* PR tree-optimization/56962 */
+
+extern void abort (void);
+long long v[144];
+
+__attribute__((noinline, noclone)) void
+bar (long long *x)
+{
+  if (x != &v[29])
+    abort ();
+}
+
+__attribute__((noinline, noclone)) void
+foo (long long *x, long y, long z)
+{
+  long long a, b, c;
+  a = x[z * 4 + y * 3];
+  b = x[z * 5 + y * 3];
+  c = x[z * 5 + y * 4];
+  x[y * 4] = a;
+  bar (&x[z * 5 + y]);
+  x[z * 5 + y * 5] = b + c;
+}
+
+int
+main ()
+{
+  foo (v, 24, 1);
+  return 0;
+}
